'******************************************************************************

Global KEY_DOWN(255), KEY_LAST
Global Pfad$
Global SICHT_X, SICHT_Y

Global COUNT_DOTS
Global LEVEL_SCORE
Global LEVEL_NEXT
Global HIGHSCORE_EINTRAGEN

'******************************************************************************

Global Spr(400) As Sprite
Global Obj(200) As ObjType

Global Const NR_NOTHING = 200
Global Const NR_ANIMATOR = 201

Global Const NR_PACMAN = 1
Global Const ID_PACMAN_LEFT = 24
Global Const ID_PACMAN_RIGHT = 0
Global Const ID_PACMAN_UP = 72
Global Const ID_PACMAN_DOWN = 48

Global Const NR_MONSTER_BLUE = 2
Global Const ID_MONSTER_BLUE = 96
Global Const NR_MONSTER_GREEN = 3
Global Const ID_MONSTER_GREEN = 108
Global Const NR_MONSTER_RED = 4
Global Const ID_MONSTER_RED = 120
Global Const NR_MONSTER_BROWN = 5
Global Const ID_MONSTER_BROWN = 132
Global Const NR_MONSTER_MAGENTA = 6
Global Const ID_MONSTER_MAGENTA = 144
Global Const NR_MONSTER_HIPPIE = 7
Global Const ID_MONSTER_HIPPIE = 156

Global Const NR_ITEM_COOL = 8
Global Const ID_ITEM_COOL = 172
Global Const NR_ITEM_INVISIBLE = 9
Global Const ID_ITEM_INVISIBLE = 176
Global Const NR_ITEM_TERMINATOR = 10
Global Const ID_ITEM_TERMINATOR = 180

Global Const NR_ITEM_DEAD = 11
Global Const ID_ITEM_DEAD = 184
Global Const NR_ITEM_KEY1 = 12
Global Const ID_ITEM_KEY1 = 188
Global Const NR_ITEM_KEY2 = 13
Global Const ID_ITEM_KEY2 = 192

Global Const NR_DOT = 14
Global Const ID_DOT = 168
Global Const NR_DOOR1 = 15
Global Const ID_DOOR1 = 196
Global Const NR_DOOR2 = 16
Global Const ID_DOOR2 = 197
Global Const NR_FLAG = 17
Global Const ID_FLAG = 204

Global Const NR_SWITCH_RED = 18
Global Const ID_SWITCH_RED = 240
Global Const NR_SWITCH_GREEN = 19
Global Const ID_SWITCH_GREEN = 242
Global Const NR_SWITCH_BLUE = 20
Global Const ID_SWITCH_BLUE = 244
Global Const NR_SWITCH_YELLOW = 21
Global Const ID_SWITCH_YELLOW = 246

Global Const NR_BLOCK_RED = 22
Global Const ID_BLOCK_RED = 248
Global Const NR_BLOCK_GREEN = 23
Global Const ID_BLOCK_GREEN = 249
Global Const NR_BLOCK_BLUE = 24
Global Const ID_BLOCK_BLUE = 250
Global Const NR_BLOCK_YELLOW = 25
Global Const ID_BLOCK_YELLOW = 251

Global Const NR_TELE_RED = 26
Global Const ID_TELE_RED = 252
Global Const NR_TELE_YELLOW = 27
Global Const ID_TELE_YELLOW = 264
Global Const NR_TELE_BLUE = 28
Global Const ID_TELE_BLUE = 260
Global Const NR_TELE_GREEN = 29
Global Const ID_TELE_GREEN = 256

Global Const ID_WALL_GRAY = 276
Global Const ID_WALL_YELLOW = 280
Global Const ID_WALL_ORANGE = 284
Global Const ID_WALL_RED = 288
Global Const ID_WALL_MAGENTA = 292
Global Const ID_WALL_BLUE = 296
Global Const ID_WALL_CYAN = 300
Global Const ID_WALL_GREEN = 304
Global Const ID_WALL_BROWN = 308

Global Const ID_ENERGY = 216
Global Const ID_TIME = 233

'
' Diese Prozedur wird aufgerufen, um darauf zu reagieren, da Pacman ein
' Monster berhrt hat. Normalerweise bekommt Pacman dann Energie abgezogen.
' Hat Pacman jedoch die "Terminator-Rune", so wird dem Monster energie
' abgezogen
'
Sub MONSTER_COLL (Self As ObjType, Other As ObjType, Hit, Speed, FRAME)
                    
    If Other.T = NR_PACMAN Then
        If OBJ_ITEM_HAVE(Other, NR_ITEM_TERMINATOR) Then
            Self.E = Self.E - 10
            WAV_PLAYBACK Pfad$ + "DOT.WAV"
            If Self.E < 0 Then
            
                Self.T = NR_ANIMATOR
                Self.R3 = FRAME + 8
                LEVEL_SCORE = LEVEL_SCORE + Hit * 2
                WAV_PLAYBACK Pfad$ + "MONSTER.WAV"
                
            End If
        Else
            Other.E = Other.E - Hit
        End If
    Else
        Self.X = Self.OX
        Self.Y = Self.OY
        MONSTER_RANDOM_SPEED Self, Speed
    End If

End Sub

Sub MONSTER_DRAW (Self As ObjType, Default)
                    
    OBJ_ANIMATE Self.R1, 3, Self.R2, 3
    If OBJ_ITEM_HAVE(Obj(0), NR_ITEM_TERMINATOR) Then
        Self.FRAME = Spr(Default + Self.R2 + 4)
    Else
        Self.FRAME = Spr(Default + Self.R2)
    End If
    If Self.SX = 0 And Self.SY = 0 Then
        MONSTER_RANDOM_SPEED Self, 2
    End If

End Sub

Sub MONSTER_HUNT (Self As ObjType, View, Speed)
                    
    If Obj(0).V = 0 Then Exit Sub

    If Abs(Obj(0).X - Self.X) < View Then
        If Abs(Obj(0).Y - Self.Y) < View Then
                            
            Self.SX = 0
            Self.SY = 0

            PacX = Fix(Obj(0).X / Speed)
            PacY = Fix(Obj(0).Y / Speed)
            MyX = Fix(Self.X / Speed)
            MyY = Fix(Self.Y / Speed)

            If OBJ_ITEM_HAVE(Obj(0), NR_ITEM_TERMINATOR) = 0 Then
                If PacX < MyX And OBJ_LEFT(Self, 20) Then Self.SX = -Speed
                If PacX > MyX And OBJ_RIGHT(Self, 20) Then Self.SX = Speed
                If PacY < MyY And OBJ_UP(Self, 20) Then Self.SY = -Speed
                If PacY > MyY And OBJ_DOWN(Self, 20) Then Self.SY = Speed
            Else
                If PacX < MyX And OBJ_RIGHT(Self, 20) Then Self.SX = Speed
                If PacX > MyX And OBJ_LEFT(Self, 20) Then Self.SX = -Speed
                If PacY < MyY And OBJ_DOWN(Self, 20) Then Self.SY = Speed
                If PacY > MyY And OBJ_UP(Self, 20) Then Self.SY = -Speed
            End If
            
            If Self.SX = 0 And Self.SY = 0 Then
                MONSTER_RANDOM_SPEED Self, Speed
            End If

        End If
    End If

End Sub

Sub MONSTER_MOVE (Self As ObjType, Par1, Par2, Speed)
                    
    Self.OX = Self.X
    Self.OY = Self.Y
    Self.X = Self.X + Par1
    Self.Y = Self.Y + Par2
    OBJ_COLL_FIELD Self
                    
    Ways = 0
    If OBJ_LEFT(Self, 20) Then Ways = Ways + 1
    If OBJ_RIGHT(Self, 20) Then Ways = Ways + 1
    If OBJ_UP(Self, 20) Then Ways = Ways + 1
    If OBJ_DOWN(Self, 20) Then Ways = Ways + 1
                    
    Chance = 2
    If Ways > 2 Then Chance = 20

    If Rnd * 200 < Chance Then
        MONSTER_RANDOM_SPEED Self, Speed
    End If


End Sub

Sub MONSTER_RANDOM_SPEED (Self As ObjType, S)
                        
    A = Fix(Rnd * 4)
    Select Case A
        Case 0: Self.SX = -S: Self.SY = 0
        Case 1: Self.SX = 0: Self.SY = -S
        Case 2: Self.SX = S: Self.SY = 0
        Case 3: Self.SX = 0: Self.SY = S
    End Select

End Sub

Sub PACMAN_INIT ()
    
    'Pfad$ = "E:\DATEN\DOCS\VBKURS\SPIELE\PACMAN\"
    Pfad$ = CurDir$
    If Right$(Pfad$, 1) <> "\" Then Pfad$ = Pfad$ + "\"
    
    MAX_DIFF = 3
    
    B1 = RES_NEW(): RES_LOAD B1, Pfad$ + "BIT\PACMAN.BMP"
    M1 = RES_NEW(): RES_LOAD M1, Pfad$ + "MASKE\PACMAN.BMP"
    
    B2 = RES_NEW(): RES_LOAD B2, Pfad$ + "BIT\MONSTER.BMP"
    M2 = RES_NEW(): RES_LOAD M2, Pfad$ + "MASKE\MONSTER.BMP"

    B3 = RES_NEW(): RES_LOAD B3, Pfad$ + "BIT\OBJECTS.BMP"
    M3 = RES_NEW(): RES_LOAD M3, Pfad$ + "MASKE\OBJECTS.BMP"
    
    B4 = RES_NEW(): RES_LOAD B4, Pfad$ + "BIT\WALLS.BMP"
    M4 = RES_NEW(): RES_LOAD M4, Pfad$ + "MASKE\WALLS.BMP"

    Anzahl = 0
    SPRITE_SET_MESH Spr(), Anzahl, 12, 8, 20, 20, RESSOURCEN.RES(B1), RESSOURCEN.RES(M1)
    SPRITE_SET_MESH Spr(), Anzahl, 12, 6, 20, 20, RESSOURCEN.RES(B2), RESSOURCEN.RES(M2)
    SPRITE_SET_MESH Spr(), Anzahl, 12, 9, 20, 20, RESSOURCEN.RES(B3), RESSOURCEN.RES(M3)
    SPRITE_SET_MESH Spr(), Anzahl, 12, 4, 20, 20, RESSOURCEN.RES(B4), RESSOURCEN.RES(M4)

End Sub

Sub PACMAN_LOAD (Datei$, BACK$)
    
    On Local Error Resume Next
    MAIN.BACK.Picture = LoadPicture(Pfad$ + "ELSE\" + BACK$)

    COUNT_DOTS = 0
    
    Open Pfad$ + Datei$ For Input As #1
    Do
        Line Input #1, A$
        Zeilen = Zeilen + 1
    Loop Until EOF(1)
    Close #1
    Spalten = Len(A$)

    FIELD_SIZE Spalten - 1, Zeilen - 1, 20, 20
    
    For M = 0 To UBound(Obj)
        OBJ_CLEAR Obj(M)
    Next M
    
    KEY_DOWN(37) = 0
    KEY_DOWN(38) = 0
    KEY_DOWN(39) = 0
    KEY_DOWN(40) = 0

    Y = 0
    AObj = 0
    OBJ_SET Obj(AObj), 0, 0, 100, 0, 0, NR_PACMAN, Spr(ID_PACMAN_DOWN), 1
    AObj = AObj + 1

    Open Pfad$ + Datei$ For Input As #1
    Do
        Line Input #1, A$
        For X = 0 To Len(A$) - 1
            
            Zeichen$ = Mid$(A$, X + 1, 1)
            Select Case Zeichen$
                
                Case "!": FIELD_SET X, Y, 1, Spr(ID_WALL_GRAY + Fix(Rnd * 4)), 1
                Case Chr$(34): FIELD_SET X, Y, 1, Spr(ID_WALL_YELLOW + Fix(Rnd * 4)), 1
                Case "": FIELD_SET X, Y, 1, Spr(ID_WALL_ORANGE + Fix(Rnd * 4)), 1
                Case "$": FIELD_SET X, Y, 1, Spr(ID_WALL_RED + Fix(Rnd * 4)), 1
                Case "%": FIELD_SET X, Y, 1, Spr(ID_WALL_MAGENTA + Fix(Rnd * 4)), 1
                Case "&": FIELD_SET X, Y, 1, Spr(ID_WALL_BLUE + Fix(Rnd * 4)), 1
                Case "/": FIELD_SET X, Y, 1, Spr(ID_WALL_CYAN + Fix(Rnd * 4)), 1
                Case "(": FIELD_SET X, Y, 1, Spr(ID_WALL_GREEN + Fix(Rnd * 4)), 1
                Case ")": FIELD_SET X, Y, 1, Spr(ID_WALL_BROWN + Fix(Rnd * 4)), 1

                Case "P": Obj(0).X = X * 20: Obj(0).Y = Y * 20
                
                Case "C": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_ITEM_COOL, Spr(ID_ITEM_COOL), 1: AObj = AObj + 1
                Case "I": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_ITEM_INVISIBLE, Spr(ID_ITEM_INVISIBLE), 1: AObj = AObj + 1
                Case "T": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_ITEM_TERMINATOR, Spr(ID_ITEM_TERMINATOR), 1: AObj = AObj + 1

                Case "X": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_ITEM_DEAD, Spr(ID_ITEM_DEAD), 1: AObj = AObj + 1

                Case "1"
                    OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_MONSTER_BLUE, Spr(ID_MONSTER_BLUE), 1: AObj = AObj + 1
                    
                Case "2"
                    OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_MONSTER_GREEN, Spr(ID_MONSTER_GREEN), 1: AObj = AObj + 1
                    
                Case "3"
                    OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_MONSTER_RED, Spr(ID_MONSTER_RED), 1: AObj = AObj + 1
                    
                Case "4"
                    OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_MONSTER_BROWN, Spr(ID_MONSTER_BROWN), 1: AObj = AObj + 1
                    
                Case "5"
                    OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_MONSTER_MAGENTA, Spr(ID_MONSTER_MAGENTA), 1: AObj = AObj + 1
                    
                Case "6"
                    OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_MONSTER_HIPPIE, Spr(ID_MONSTER_HIPPIE), 1: AObj = AObj + 1
                    
                Case "k": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_ITEM_KEY1, Spr(ID_ITEM_KEY1), 1: AObj = AObj + 1
                Case "K": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_ITEM_KEY2, Spr(ID_ITEM_KEY2), 1: AObj = AObj + 1

                Case "d": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_DOOR1, Spr(ID_DOOR1), 1: AObj = AObj + 1
                Case "D": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_DOOR2, Spr(ID_DOOR2), 1: AObj = AObj + 1

                Case "."
                    OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_DOT, Spr(ID_DOT), 1: AObj = AObj + 1
                    COUNT_DOTS = COUNT_DOTS + 1

                Case "F": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_FLAG, Spr(ID_FLAG), 1: AObj = AObj + 1

                Case "R": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_SWITCH_RED, Spr(ID_SWITCH_RED), 1: AObj = AObj + 1
                Case "G": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_SWITCH_GREEN, Spr(ID_SWITCH_GREEN), 1: AObj = AObj + 1
                Case "B": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_SWITCH_BLUE, Spr(ID_SWITCH_BLUE), 1: AObj = AObj + 1
                Case "Y": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_SWITCH_YELLOW, Spr(ID_SWITCH_YELLOW), 1: AObj = AObj + 1

                Case "r": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_BLOCK_RED, Spr(ID_BLOCK_RED), 1: AObj = AObj + 1
                Case "g": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_BLOCK_GREEN, Spr(ID_BLOCK_GREEN), 1: AObj = AObj + 1
                Case "b": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_BLOCK_BLUE, Spr(ID_BLOCK_BLUE), 1: AObj = AObj + 1
                Case "y": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_BLOCK_YELLOW, Spr(ID_BLOCK_YELLOW), 1: AObj = AObj + 1

                Case "7": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_TELE_RED, Spr(ID_TELE_RED), 1: AObj = AObj + 1
                Case "8": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_TELE_GREEN, Spr(ID_TELE_GREEN), 1: AObj = AObj + 1
                Case "9": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_TELE_BLUE, Spr(ID_TELE_BLUE), 1: AObj = AObj + 1
                Case "0": OBJ_SET Obj(AObj), X * 20, Y * 20, 100, 0, 0, NR_TELE_YELLOW, Spr(ID_TELE_YELLOW), 1: AObj = AObj + 1

            End Select

        Next X
        Y = Y + 1
    Loop Until EOF(1)
    Close #1

End Sub

Sub PACMAN_RUN ()
        
    Obj(0).SX = 0
    Obj(0).SY = 0

    If KEY_DOWN(38) And OBJ_UP(Obj(0), 4) Then Obj(0).SY = -4
    If KEY_DOWN(40) And OBJ_DOWN(Obj(0), 4) Then Obj(0).SY = 4
    If KEY_DOWN(37) And OBJ_LEFT(Obj(0), 4) Then Obj(0).SX = -4
    If KEY_DOWN(39) And OBJ_RIGHT(Obj(0), 4) Then Obj(0).SX = 4

    PACMAN_SHOW
    
End Sub

Sub PACMAN_SHOW ()
    
    SICHT_X = Fix(MAIN.DISPLAY.ScaleWidth / 2 - Obj(0).X)
    SICHT_Y = Fix(MAIN.DISPLAY.ScaleHeight / 2 - Obj(0).Y)
    
    If SICHT_X > 0 Then SICHT_X = 0
    If SICHT_Y > 0 Then SICHT_Y = 0
    If SICHT_X + ((FIELD_X + 1) * FIELD_W - MAIN.DISPLAY.ScaleWidth) < 0 Then SICHT_X = -((FIELD_X + 1) * FIELD_W - MAIN.DISPLAY.ScaleWidth)
    If SICHT_Y + ((FIELD_Y + 1) * FIELD_H - MAIN.DISPLAY.ScaleHeight) < 0 Then SICHT_Y = -((FIELD_Y + 1) * FIELD_H - MAIN.DISPLAY.ScaleHeight)
    
    MAIN.DISPLAY.Cls
    FIELD_DRAW MAIN.DISPLAY, SICHT_X, SICHT_Y

    For M = 0 To UBound(Obj)
        OBJ_DRAW Obj(M), SICHT_X, SICHT_Y, MAIN.DISPLAY
    Next M

    For M = 0 To UBound(Obj)
        
        OBJ_EVENT Obj(M), ID_MOVE, ObjDummy, Obj(M).SX, Obj(M).SY
        
        If Obj(M).T = NR_PACMAN Then
            For M2 = M + 1 To UBound(Obj)
                OBJ_COLL_OBJ Obj(M), Obj(M2)
            Next M2
        Else
            If Obj(M).SX <> 0 Or Obj(M).SY <> 0 Then
                For M2 = 0 To UBound(Obj)
                    Need = 0
                    Select Case Obj(M2).T
                        
                        Case NR_BLOCK_RED: Need = 1
                        Case NR_BLOCK_BLUE: Need = 1
                        Case NR_BLOCK_GREEN: Need = 1
                        Case NR_BLOCK_YELLOW: Need = 1
                        Case NR_DOOR1: Need = 1
                        Case NR_DOOR2: Need = 1

                    End Select
                    If Need Then OBJ_COLL_OBJ Obj(M), Obj(M2)
                Next M2
            End If
        End If
        
    Next M
    
    '12+5 - 7

    PowerUp = 0
    E = OBJ_ITEM_ENERGY_GET(Obj(0), NR_ITEM_COOL)
    If E > PowerUp Then PowerUp = E
    E = OBJ_ITEM_ENERGY_GET(Obj(0), NR_ITEM_INVISIBLE)
    If E > PowerUp Then PowerUp = E
    E = OBJ_ITEM_ENERGY_GET(Obj(0), NR_ITEM_TERMINATOR)
    If E > PowerUp Then PowerUp = E

    If PowerUp > 0 Then
        PowerUp = 6 / 300 * PowerUp
        If PowerUp <= 6 Then
            SPRITE_DRAW Spr(ID_TIME + 6 - PowerUp), 25, 5, MAIN.DISPLAY
        End If
    End If

    If Obj(0).E >= 0 Then
        Energy = 16 / 100 * Obj(0).E
        SPRITE_DRAW Spr(ID_ENERGY + 16 - Energy), 5, 5, MAIN.DISPLAY
    Else
        LEVEL_NEXT = -2
    End If
    
    MAIN.DISPLAY.Refresh
    
End Sub

Sub USER_EVENT (Self As ObjType, MESSAGE, Other As ObjType, Par1, Par2)

    If Self.T = 0 Then Exit Sub
    
    USER_EVENT_PACMAN Self, MESSAGE, Other, Par1, Par2
    USER_EVENT_DOORS Self, MESSAGE, Other, Par1, Par2
    USER_EVENT_ITEM Self, MESSAGE, Other, Par1, Par2
    USER_EVENT_MONSTER Self, MESSAGE, Other, Par1, Par2
    USER_EVENT_SWITCH Self, MESSAGE, Other, Par1, Par2
    USER_EVENT_TELE Self, MESSAGE, Other, Par1, Par2
    
End Sub

Sub USER_EVENT_DOORS (Self As ObjType, MESSAGE, Other As ObjType, Par1, Par2)
    
    Select Case Self.T
        
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
            
        Case NR_ITEM_KEY1
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        Anzahl = OBJ_ITEM_ENERGY_GET(Other, NR_ITEM_KEY1) + 1
                        OBJ_ITEM_ENERGY_SET Other, NR_ITEM_KEY1, Anzahl
                        OBJ_CLEAR Self
                        WAV_PLAYBACK Pfad$ + "ITEM.WAV"
                    End If

                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 3, Self.R2, 3
                    Self.FRAME = Spr(ID_ITEM_KEY1 + Self.R2)

            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
            
        Case NR_ITEM_KEY2
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        Anzahl = OBJ_ITEM_ENERGY_GET(Other, NR_ITEM_KEY2) + 1
                        OBJ_ITEM_ENERGY_SET Other, NR_ITEM_KEY2, Anzahl
                        OBJ_CLEAR Self
                        WAV_PLAYBACK Pfad$ + "ITEM.WAV"
                    End If

                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 3, Self.R2, 3
                    Self.FRAME = Spr(ID_ITEM_KEY2 + Self.R2)

            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************

        Case NR_DOOR1
            Select Case MESSAGE

                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        If OBJ_ITEM_HAVE(Other, NR_ITEM_KEY1) Then
                            Anzahl = OBJ_ITEM_ENERGY_GET(Other, NR_ITEM_KEY1) - 1
                            OBJ_ITEM_ENERGY_SET Other, NR_ITEM_KEY1, Anzahl
                            OBJ_CLEAR Self
                            WAV_PLAYBACK Pfad$ + "TR.WAV"
                        Else
                            Other.X = Other.OX
                            Other.Y = Other.OY
                            Other.SX = 0
                            Other.SY = 0
                        End If
                    End If
                
            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************

        Case NR_DOOR2
            Select Case MESSAGE

                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        If OBJ_ITEM_HAVE(Other, NR_ITEM_KEY2) Then
                            Anzahl = OBJ_ITEM_ENERGY_GET(Other, NR_ITEM_KEY2) - 1
                            OBJ_ITEM_ENERGY_SET Other, NR_ITEM_KEY2, Anzahl
                            OBJ_CLEAR Self
                            WAV_PLAYBACK Pfad$ + "TR.WAV"
                        Else
                            Other.X = Other.OX
                            Other.Y = Other.OY
                            Other.SX = 0
                            Other.SY = 0
                        End If
                    End If
                
            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
    
    End Select

End Sub

Sub USER_EVENT_ITEM (Self As ObjType, MESSAGE, Other As ObjType, Par1, Par2)
    
    Select Case Self.T

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************

        Case NR_ITEM_COOL:  ' Speed-PowerUp
            Select Case MESSAGE
                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        OBJ_ITEM_DROP Other, NR_ITEM_COOL
                        OBJ_ITEM_DROP Other, NR_ITEM_INVISIBLE
                        OBJ_ITEM_DROP Other, NR_ITEM_TERMINATOR
                        OBJ_ITEM_GET Other, NR_ITEM_COOL, 300
                        OBJ_CLEAR Self
                        LEVEL_SCORE = LEVEL_SCORE + 20
                        WAV_PLAYBACK Pfad$ + "ITEM.WAV"
                    End If
                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 3, Self.R2, 3
                    Self.FRAME = Spr(ID_ITEM_COOL + Self.R2)
            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_ITEM_INVISIBLE:  ' Unsichtbar-PowerUp
            Select Case MESSAGE
                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        OBJ_ITEM_DROP Other, NR_ITEM_COOL
                        OBJ_ITEM_DROP Other, NR_ITEM_INVISIBLE
                        OBJ_ITEM_DROP Other, NR_ITEM_TERMINATOR
                        OBJ_ITEM_GET Other, NR_ITEM_INVISIBLE, 300
                        OBJ_CLEAR Self
                        LEVEL_SCORE = LEVEL_SCORE + 10
                        WAV_PLAYBACK Pfad$ + "ITEM.WAV"
                    End If
                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 3, Self.R2, 3
                    Self.FRAME = Spr(ID_ITEM_INVISIBLE + Self.R2)
            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_ITEM_TERMINATOR:  ' Terminator-PowerUp
            Select Case MESSAGE
                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        OBJ_ITEM_DROP Other, NR_ITEM_COOL
                        OBJ_ITEM_DROP Other, NR_ITEM_INVISIBLE
                        OBJ_ITEM_DROP Other, NR_ITEM_TERMINATOR
                        OBJ_ITEM_GET Other, NR_ITEM_TERMINATOR, 300
                        OBJ_CLEAR Self
                        LEVEL_SCORE = LEVEL_SCORE + 10
                        WAV_PLAYBACK Pfad$ + "ITEM.WAV"
                    End If
                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 3, Self.R2, 3
                    Self.FRAME = Spr(ID_ITEM_TERMINATOR + Self.R2)
            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************

        Case NR_ITEM_DEAD:  ' Todes-"PowerUp"
            Select Case MESSAGE
                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        Other.E = Other.E - 80
                        OBJ_CLEAR Self
                        WAV_PLAYBACK Pfad$ + "ITEM.WAV"
                    End If
                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 3, Self.R2, 3
                    Self.FRAME = Spr(ID_ITEM_DEAD + Self.R2)
            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
    
    End Select

End Sub

Sub USER_EVENT_MONSTER (Self As ObjType, MESSAGE, Other As ObjType, Par1, Par2)
    
    Select Case Self.T

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_MONSTER_BLUE

            Select Case MESSAGE
                Case ID_DRAW
                    MONSTER_DRAW Self, ID_MONSTER_BLUE
                Case ID_MOVE
                    MONSTER_MOVE Self, Par1, Par2, 2
                    MONSTER_HUNT Self, 20, 2
                Case ID_COLL, ID_COLL_WALL
                    MONSTER_COLL Self, Other, 2, 2, ID_MONSTER_BLUE
            End Select


        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_MONSTER_GREEN

            Select Case MESSAGE
                Case ID_DRAW
                    MONSTER_DRAW Self, ID_MONSTER_GREEN
                Case ID_MOVE
                    MONSTER_MOVE Self, Par1, Par2, 2
                    MONSTER_HUNT Self, 40, 2
                Case ID_COLL, ID_COLL_WALL
                    MONSTER_COLL Self, Other, 1, 2, ID_MONSTER_GREEN
            End Select


        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_MONSTER_RED

            Select Case MESSAGE
                Case ID_DRAW
                    MONSTER_DRAW Self, ID_MONSTER_RED
                Case ID_MOVE
                    MONSTER_MOVE Self, Par1, Par2, 3
                    MONSTER_HUNT Self, 40, 3
                Case ID_COLL, ID_COLL_WALL
                    MONSTER_COLL Self, Other, 4, 3, ID_MONSTER_RED
            End Select


        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_MONSTER_BROWN

            Select Case MESSAGE
                Case ID_DRAW
                    MONSTER_DRAW Self, ID_MONSTER_BROWN
                Case ID_MOVE
                    MONSTER_MOVE Self, Par1, Par2, 3
                    MONSTER_HUNT Self, 80, 3
                Case ID_COLL, ID_COLL_WALL
                    MONSTER_COLL Self, Other, 3, 3, ID_MONSTER_BROWN
            End Select


        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_MONSTER_MAGENTA

            Select Case MESSAGE
                Case ID_DRAW
                    MONSTER_DRAW Self, ID_MONSTER_MAGENTA
                Case ID_MOVE
                    MONSTER_MOVE Self, Par1, Par2, 3
                    MONSTER_HUNT Self, 80, 5
                Case ID_COLL, ID_COLL_WALL
                    MONSTER_COLL Self, Other, 8, 3, ID_MONSTER_MAGENTA
            End Select


        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_MONSTER_HIPPIE

            Select Case MESSAGE
                Case ID_DRAW
                    MONSTER_DRAW Self, ID_MONSTER_HIPPIE
                Case ID_MOVE
                    MONSTER_MOVE Self, Par1, Par2, 3
                    MONSTER_HUNT Self, 100, 6
                Case ID_COLL, ID_COLL_WALL
                    MONSTER_COLL Self, Other, 20, 4, ID_MONSTER_HIPPIE
            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
    End Select

End Sub

Sub USER_EVENT_PACMAN (Self As ObjType, MESSAGE, Other As ObjType, Par1, Par2)
    
    Select Case Self.T

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_PACMAN:     ' Pacman
            Select Case MESSAGE
                
                Case ID_DRAW
                    
                    OBJ_ANIMATE Self.R1, 3, Self.R2, 3
                    
                    Self.R3 = 0
                    Self.V = 1

                    If OBJ_ITEM_HAVE(Self, NR_ITEM_COOL) Then
                        Energy = OBJ_ITEM_ENERGY_GET(Self, NR_ITEM_COOL)
                        If Energy > 0 Then
                            OBJ_ITEM_ENERGY_SET Self, NR_ITEM_COOL, Energy - 1
                            Self.R3 = 12
                            For M = 0 To UBound(Obj)
                                If Obj(M).T <> NR_PACMAN Then
                                    Obj(M).X = Obj(M).OX
                                    Obj(M).Y = Obj(M).OY
                                End If
                            Next M
                        Else
                            OBJ_ITEM_DROP Self, NR_ITEM_COOL
                        End If
                    End If

                    If OBJ_ITEM_HAVE(Self, NR_ITEM_INVISIBLE) Then
                        Energy = OBJ_ITEM_ENERGY_GET(Self, NR_ITEM_INVISIBLE)
                        If Energy > 0 Then
                            OBJ_ITEM_ENERGY_SET Self, NR_ITEM_INVISIBLE, Energy - 1
                            Self.R3 = 8
                            Self.V = 0
                        Else
                            OBJ_ITEM_DROP Self, NR_ITEM_INVISIBLE
                        End If
                    End If

                    If OBJ_ITEM_HAVE(Self, NR_ITEM_TERMINATOR) Then
                        Energy = OBJ_ITEM_ENERGY_GET(Self, NR_ITEM_TERMINATOR)
                        If Energy > 0 Then
                            OBJ_ITEM_ENERGY_SET Self, NR_ITEM_TERMINATOR, Energy - 1
                            Self.R3 = 4
                            Self.SX = Self.SX * 1.5
                            Self.SY = Self.SY * 1.5
                        Else
                            OBJ_ITEM_DROP Self, NR_ITEM_TERMINATOR
                        End If
                    End If

                    Self.FRAME = Spr(ID_PACMAN_DOWN + Self.R3)
                    If Self.SY < 0 Then Self.FRAME = Spr(ID_PACMAN_UP + Self.R2 + Self.R3)
                    If Self.SY > 0 Then Self.FRAME = Spr(ID_PACMAN_DOWN + Self.R2 + Self.R3)
                    If Self.SX > 0 Then Self.FRAME = Spr(ID_PACMAN_RIGHT + Self.R2 + Self.R3)
                    If Self.SX < 0 Then Self.FRAME = Spr(ID_PACMAN_LEFT + Self.R2 + Self.R3)

                Case ID_MOVE
                    Self.OX = Self.X
                    Self.OY = Self.Y
                    Self.X = Self.X + Par1
                    Self.Y = Self.Y + Par2
                    OBJ_COLL_FIELD Self

                Case ID_COLL_WALL
                    Self.X = Self.OX
                    Self.Y = Self.OY
                    Self.SX = Self.SX / 2
                    Self.SY = Self.SY / 2
                    OBJ_EVENT Self, ID_MOVE, ObjDummy, Self.SX, Self.SY
                    
            End Select

        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_DOT:        ' Punkte
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        Dots = OBJ_ITEM_ENERGY_GET(Other, NR_DOT) + 1
                        OBJ_ITEM_ENERGY_SET Other, NR_DOT, Dots
                        OBJ_CLEAR Self
                        LEVEL_SCORE = LEVEL_SCORE + 5
                        WAV_PLAYBACK Pfad$ + "DOT.WAV"
                    End If

                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 0, Self.R2, 3
                    Self.FRAME = Spr(ID_DOT + Self.R2)

            End Select
        
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************

        Case NR_FLAG:        ' Flagge
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        If COUNT_DOTS = OBJ_ITEM_ENERGY_GET(Other, NR_DOT) Then
                            LEVEL_NEXT = 1
                            LEVEL_SCORE = LEVEL_SCORE + 50
                        End If
                    End If

                Case ID_DRAW
                    If COUNT_DOTS = OBJ_ITEM_ENERGY_GET(Obj(0), NR_DOT) Then
                        OBJ_ANIMATE Self.R1, 1, Self.R2, 9
                        Self.FRAME = Spr(ID_FLAG + Self.R2)
                    Else
                        Self.FRAME = Spr(ID_FLAG)
                    End If

            End Select
        
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************

        Case NR_ANIMATOR:
            Select Case MESSAGE
                
                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 0, Self.R2, 3
                    Self.FRAME = Spr(Self.R3 + Self.R2)

            End Select
            
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************

    End Select

End Sub

Sub USER_EVENT_SWITCH (Self As ObjType, MESSAGE, Other As ObjType, Par1, Par2)
    
    Select Case Self.T
    
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_SWITCH_RED
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN And Self.R1 = 0 Then
                        Self.R1 = 1
                        For M = 0 To UBound(Obj)
                            If Obj(M).T = NR_BLOCK_RED Then OBJ_CLEAR Obj(M)
                        Next M
                        WAV_PLAYBACK Pfad$ + "SCHALTER.WAV"
                    End If

                Case ID_DRAW
                    Self.FRAME = Spr(ID_SWITCH_RED + Self.R1)

            End Select
        
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_SWITCH_GREEN
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN And Self.R1 = 0 Then
                        Self.R1 = 1
                        For M = 0 To UBound(Obj)
                            If Obj(M).T = NR_BLOCK_GREEN Then OBJ_CLEAR Obj(M)
                        Next M
                        WAV_PLAYBACK Pfad$ + "SCHALTER.WAV"
                    End If

                Case ID_DRAW
                    Self.FRAME = Spr(ID_SWITCH_GREEN + Self.R1)

            End Select
        
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_SWITCH_BLUE
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN And Self.R1 = 0 Then
                        Self.R1 = 1
                        For M = 0 To UBound(Obj)
                            If Obj(M).T = NR_BLOCK_BLUE Then OBJ_CLEAR Obj(M)
                        Next M
                        WAV_PLAYBACK Pfad$ + "SCHALTER.WAV"
                    End If

                Case ID_DRAW
                    Self.FRAME = Spr(ID_SWITCH_BLUE + Self.R1)

            End Select
        
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_SWITCH_YELLOW
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN And Self.R1 = 0 Then
                        Self.R1 = 1
                        For M = 0 To UBound(Obj)
                            If Obj(M).T = NR_BLOCK_YELLOW Then OBJ_CLEAR Obj(M)
                        Next M
                        WAV_PLAYBACK Pfad$ + "SCHALTER.WAV"
                    End If

                Case ID_DRAW
                    Self.FRAME = Spr(ID_SWITCH_YELLOW + Self.R1)

            End Select
        
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************

        Case NR_BLOCK_RED, NR_BLOCK_GREEN, NR_BLOCK_BLUE, NR_BLOCK_YELLOW
            Select Case MESSAGE

                Case ID_COLL
                    If Other.T = NR_PACMAN Then
                        Other.X = Other.OX
                        Other.Y = Other.OY
                        Other.SX = 0
                        Other.SY = 0
                    End If
                
            End Select

    End Select

End Sub

Sub USER_EVENT_TELE (Self As ObjType, MESSAGE, Other As ObjType, Par1, Par2)
    
    Select Case Self.T
    
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_TELE_RED
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN And Self.R1 = 0 Then
                        For M = 0 To UBound(Obj)
                            If Obj(M).T = NR_TELE_RED And (Obj(M).X <> Self.X Or Obj(M).Y <> Self.Y) Then
                                Other.X = Obj(M).X
                                Other.Y = Obj(M).Y
                                WAV_PLAYBACK Pfad$ + "TELEPORT.WAV"
                                If OBJ_LEFT(Obj(M), 20) Then Other.X = Other.X - 20: Exit Sub
                                If OBJ_RIGHT(Obj(M), 20) Then Other.X = Other.X + 20: Exit Sub
                                If OBJ_UP(Obj(M), 20) Then Other.Y = Other.Y - 20: Exit Sub
                                If OBJ_DOWN(Obj(M), 20) Then Other.Y = Other.Y + 20: Exit Sub
                            End If
                        Next M
                    End If

                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 0, Self.R2, 3
                    Self.FRAME = Spr(ID_TELE_RED + Self.R2 + Self.R3)

            End Select
    
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_TELE_BLUE
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN And Self.R1 = 0 Then
                        For M = 0 To UBound(Obj)
                            If Obj(M).T = NR_TELE_BLUE And (Obj(M).X <> Self.X Or Obj(M).Y <> Self.Y) Then
                                Other.X = Obj(M).X
                                Other.Y = Obj(M).Y
                                WAV_PLAYBACK Pfad$ + "TELEPORT.WAV"
                                If OBJ_LEFT(Obj(M), 20) Then Other.X = Other.X - 20: Exit Sub
                                If OBJ_RIGHT(Obj(M), 20) Then Other.X = Other.X + 20: Exit Sub
                                If OBJ_UP(Obj(M), 20) Then Other.Y = Other.Y - 20: Exit Sub
                                If OBJ_DOWN(Obj(M), 20) Then Other.Y = Other.Y + 20: Exit Sub
                            End If
                        Next M
                    End If

                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 0, Self.R2, 3
                    Self.FRAME = Spr(ID_TELE_BLUE + Self.R2 + Self.R3)

            End Select
    
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_TELE_GREEN
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN And Self.R1 = 0 Then
                        For M = 0 To UBound(Obj)
                            If Obj(M).T = NR_TELE_GREEN And (Obj(M).X <> Self.X Or Obj(M).Y <> Self.Y) Then
                                Other.X = Obj(M).X
                                Other.Y = Obj(M).Y
                                WAV_PLAYBACK Pfad$ + "TELEPORT.WAV"
                                If OBJ_LEFT(Obj(M), 20) Then Other.X = Other.X - 20: Exit Sub
                                If OBJ_RIGHT(Obj(M), 20) Then Other.X = Other.X + 20: Exit Sub
                                If OBJ_UP(Obj(M), 20) Then Other.Y = Other.Y - 20: Exit Sub
                                If OBJ_DOWN(Obj(M), 20) Then Other.Y = Other.Y + 20: Exit Sub
                            End If
                        Next M
                    End If

                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 0, Self.R2, 3
                    Self.FRAME = Spr(ID_TELE_GREEN + Self.R2 + Self.R3)

            End Select
    
        '**********************************************************************
        '**********************************************************************
        '**********************************************************************
        
        Case NR_TELE_YELLOW
            Select Case MESSAGE
                
                Case ID_COLL
                    If Other.T = NR_PACMAN And Self.R1 = 0 Then
                        For M = 0 To UBound(Obj)
                            If Obj(M).T = NR_TELE_YELLOW And (Obj(M).X <> Self.X Or Obj(M).Y <> Self.Y) Then
                                Other.X = Obj(M).X
                                Other.Y = Obj(M).Y
                                WAV_PLAYBACK Pfad$ + "TELEPORT.WAV"
                                If OBJ_LEFT(Obj(M), 20) Then Other.X = Other.X - 20: Exit Sub
                                If OBJ_RIGHT(Obj(M), 20) Then Other.X = Other.X + 20: Exit Sub
                                If OBJ_UP(Obj(M), 20) Then Other.Y = Other.Y - 20: Exit Sub
                                If OBJ_DOWN(Obj(M), 20) Then Other.Y = Other.Y + 20: Exit Sub
                            End If
                        Next M
                    End If

                Case ID_DRAW
                    OBJ_ANIMATE Self.R1, 0, Self.R2, 3
                    Self.FRAME = Spr(ID_TELE_YELLOW + Self.R2 + Self.R3)

            End Select
        
    End Select

End Sub

